"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.KafkaClient = exports.EventBus = void 0;
var kafkajs_1 = require("kafkajs");
var __1 = require("..");
var EventBus = /** @class */ (function () {
    function EventBus() {
    }
    return EventBus;
}());
exports.EventBus = EventBus;
;
var KafkaClient = /** @class */ (function (_super) {
    __extends(KafkaClient, _super);
    function KafkaClient() {
        var _this = _super.call(this) || this;
        _this._isProducerReq = false;
        _this._isConsumerReq = false;
        _this._clientId = null;
        _this._brokers = null;
        _this._kafka = null;
        _this._producer = null;
        _this._consumer = null;
        _this._producerConfig = null;
        _this._consumerConfig = null;
        return _this;
    }
    ;
    KafkaClient.getInstance = function () {
        if (!KafkaClient._instance)
            KafkaClient._instance = new KafkaClient();
        return KafkaClient._instance;
    };
    ;
    Object.defineProperty(KafkaClient.prototype, "producer", {
        get: function () {
            if (!this._isProducerReq)
                throw new __1.GenericValidationError({ error: new Error('Cannot get producer, if _isProducerReq is set to false'), errorCode: 500 });
            if (!this._producer)
                throw new __1.GenericValidationError({ error: new Error('Cannot get producer before initialising kafka client'), errorCode: 500 });
            return this._producer;
        },
        enumerable: false,
        configurable: true
    });
    ;
    Object.defineProperty(KafkaClient.prototype, "consumer", {
        get: function () {
            if (!this._isConsumerReq)
                throw new __1.GenericValidationError({ error: new Error('Cannot get consumer, if _isConsumerReq is set to false'), errorCode: 500 });
            if (!this._consumer)
                throw new __1.GenericValidationError({ error: new Error('Cannot get consumer before initialising kafka client'), errorCode: 500 });
            return this._consumer;
        },
        enumerable: false,
        configurable: true
    });
    ;
    Object.defineProperty(KafkaClient.prototype, "isProducerReq", {
        get: function () {
            return this._isProducerReq;
        },
        enumerable: false,
        configurable: true
    });
    ;
    Object.defineProperty(KafkaClient.prototype, "isConsumerReq", {
        get: function () {
            return this._isConsumerReq;
        },
        enumerable: false,
        configurable: true
    });
    ;
    Object.defineProperty(KafkaClient.prototype, "clientId", {
        set: function (clientId) {
            if (this._clientId)
                throw new __1.GenericValidationError({ error: new Error('_clientId cannot be changed once you set it'), errorCode: 500 });
            this._clientId = clientId;
        },
        enumerable: false,
        configurable: true
    });
    ;
    Object.defineProperty(KafkaClient.prototype, "brokers", {
        set: function (brokers) {
            if (this._brokers)
                throw new __1.GenericValidationError({ error: new Error('_brokers cannot be changed once you set it'), errorCode: 500 });
            this._brokers = brokers;
        },
        enumerable: false,
        configurable: true
    });
    ;
    Object.defineProperty(KafkaClient.prototype, "producerConfig", {
        set: function (producerConfig) {
            if (this._producerConfig)
                throw new __1.GenericValidationError({ error: new Error('_producerConfig cannot be changed once you set it'), errorCode: 500 });
            this._producerConfig = producerConfig;
        },
        enumerable: false,
        configurable: true
    });
    ;
    Object.defineProperty(KafkaClient.prototype, "consumerConfig", {
        set: function (consumerConfig) {
            if (this._consumerConfig)
                throw new __1.GenericValidationError({ error: new Error('_consumerConfig cannot be changed once you set it'), errorCode: 500 });
            this._consumerConfig = consumerConfig;
        },
        enumerable: false,
        configurable: true
    });
    ;
    KafkaClient.prototype.producerInit = function () {
        if (!this._kafka)
            throw new __1.GenericValidationError({ error: new Error('_kafka must be set to initialise kafka producer'), errorCode: 500 });
        if (this._producerConfig)
            this._producer = this._kafka.producer(this._producerConfig);
        else
            this._producer = this._kafka.producer();
    };
    ;
    KafkaClient.prototype.consumerInit = function () {
        if (!this._kafka)
            throw new __1.GenericValidationError({ error: new Error('_kafka must be set to initialise kafka consumer'), errorCode: 500 });
        if (!this._consumerConfig)
            throw new __1.GenericValidationError({ error: new Error('_consumerConfig must be set to initialise kafka consumer'), errorCode: 500 });
        this._consumer = this._kafka.consumer(this._consumerConfig);
    };
    ;
    KafkaClient.prototype.setup = function (isProducerReq, isConsumerReq) {
        if (!isProducerReq && !isConsumerReq)
            throw new __1.GenericValidationError({ error: new Error('Either producer or consumer is required to setup the kafka client'), errorCode: 500 });
        this._isProducerReq = isProducerReq;
        this._isConsumerReq = isConsumerReq;
    };
    ;
    KafkaClient.prototype.init = function () {
        if (!this._isProducerReq && !this._isConsumerReq)
            throw new __1.GenericValidationError({ error: new Error('Either producer or consumer is required to setup the kafka client'), errorCode: 500 });
        if (!this._clientId)
            throw new __1.GenericValidationError({ error: new Error('_clientId must be set before kafka client init'), errorCode: 500 });
        if (!this._brokers)
            throw new __1.GenericValidationError({ error: new Error('_brokers must be set before kafka client init'), errorCode: 500 });
        if (this._kafka)
            throw new __1.GenericValidationError({ error: new Error('init method cannot be called more than once'), errorCode: 500 });
        this._kafka = new kafkajs_1.Kafka({
            clientId: this._clientId,
            brokers: this._brokers,
        });
        if (this._isProducerReq)
            this.producerInit();
        if (this._isConsumerReq)
            this.consumerInit();
    };
    ;
    KafkaClient.prototype.onConnect = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this._isProducerReq && !this._isConsumerReq)
                            throw new __1.GenericValidationError({ error: new Error('Either producer or consumer is required to setup the kafka client'), errorCode: 500 });
                        if (!this._isProducerReq) return [3 /*break*/, 2];
                        if (!this._producer)
                            throw new __1.GenericValidationError({ error: new Error('_producer must be set before connecting kafka client'), errorCode: 500 });
                        return [4 /*yield*/, this._producer.connect()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        ;
                        if (!this._isConsumerReq) return [3 /*break*/, 4];
                        if (!this._consumer)
                            throw new __1.GenericValidationError({ error: new Error('_consumer must be set before connecting kafka client'), errorCode: 500 });
                        return [4 /*yield*/, this._consumer.connect()];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4:
                        ;
                        return [2 /*return*/];
                }
            });
        });
    };
    ;
    // Send messages using below method with the help of `kafka topics and partitions
    KafkaClient.prototype.onProduce = function (record) {
        return __awaiter(this, void 0, void 0, function () {
            var recordMetadata;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this._producer)
                            throw new __1.GenericValidationError({ error: new Error('_producer must be set before producing messages'), errorCode: 500 });
                        return [4 /*yield*/, this._producer.send(record)];
                    case 1:
                        recordMetadata = _a.sent();
                        return [2 /*return*/, recordMetadata];
                }
            });
        });
    };
    ;
    // listen messages
    KafkaClient.prototype.onConsume = function (topic) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this._consumer)
                            throw new __1.GenericValidationError({ error: new Error('_consumer must be set before consuming messages'), errorCode: 500 });
                        return [4 /*yield*/, this._consumer.subscribe(topic)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    ;
    KafkaClient.prototype.onListenEvents = function (config) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this._consumer)
                            throw new __1.GenericValidationError({ error: new Error('_consumer must be set before listening to events'), errorCode: 500 });
                        return [4 /*yield*/, this._consumer.run(config)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    ;
    return KafkaClient;
}(EventBus));
exports.KafkaClient = KafkaClient;
;
