"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AuthMiddleware = void 0;
var fs_1 = __importDefault(require("fs"));
var jsonwebtoken_1 = __importDefault(require("jsonwebtoken"));
var path_1 = require("path");
var __1 = require("..");
var mongoose_1 = __importDefault(require("mongoose"));
;
;
;
var AuthMiddleware = /** @class */ (function () {
    function AuthMiddleware() {
    }
    ;
    AuthMiddleware.getInstance = function () {
        if (!AuthMiddleware._instance)
            AuthMiddleware._instance = new AuthMiddleware();
        return AuthMiddleware._instance;
    };
    ;
    /**
 * To config the keycloak with authorized user.
 * @param realm - The name of the realm
 * @param authUrl - The url of federated identity
 * @param clientId - Name of the client
 * @param clientSecret - The secret id of the client
 * @param username - Username of the admin
 * @param password - Password of the admin
 * @returns The keycloak config
 */
    AuthMiddleware.prototype.keycloakConfig = function (realm, authUrl, clientId, clientSecret, username, password) {
        var keycloak = require('keycloak-backend')({
            "realm": realm,
            "auth-server-url": authUrl,
            "client_id": clientId,
            "client_secret": clientSecret,
            "username": username,
            "password": password
        });
        return keycloak;
    };
    ;
    /**
     * Decode the access token by the jsonwebtoken package.
     * @param accessToken - Access token from the header
     * @returns The decoded user payload
     */
    AuthMiddleware.prototype.decodeAccessToken = function (accessToken) {
        var decoded = jsonwebtoken_1.default.decode(accessToken);
        if (!decoded)
            throw new __1.GenericValidationError({ error: new Error('Access denied. No token provided.'), errorCode: 401 });
        return decoded;
    };
    /**
     * Verify the access token with online by keycloak.
     * @param accessToken - Access token from the header
     * @returns The online verified user payload
     */
    AuthMiddleware.prototype.verifyOnlineAccessToken = function (accessToken) {
        return __awaiter(this, void 0, void 0, function () {
            var nconf, keycloak, verifiedToken, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        nconf = __1.Nconf.getInstance().nconf;
                        keycloak = this.keycloakConfig(nconf.get('realm'), nconf.get('AUTH_URL'), nconf.get('clientId'), nconf.get('CLIENT_SECRET'), nconf.get('ADMIN_NAME'), nconf.get('ADMIN_PASSWORD'));
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, keycloak.jwt.verify(accessToken)];
                    case 2:
                        verifiedToken = _a.sent();
                        return [2 /*return*/, verifiedToken.content];
                    case 3:
                        err_1 = _a.sent();
                        throw new __1.GenericValidationError({ error: new Error('Token not valid'), errorCode: 401 });
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Verify the access token with offline by keycloak.
     * @param accessToken - Access token from the header
     * @returns The offline verified user payload
     */
    AuthMiddleware.prototype.verifyOfflineAccessToken = function (accessToken) {
        return __awaiter(this, void 0, void 0, function () {
            var nconf, keycloak, cert, verifiedToken, err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        nconf = __1.Nconf.getInstance().nconf;
                        keycloak = this.keycloakConfig(nconf.get('realm'), nconf.get('authUrl'), nconf.get('clientId'), nconf.get('clientSecret'), nconf.get('keycloakUsername'), nconf.get('keycloakPassword'));
                        cert = fs_1.default.readFileSync((0, path_1.join)(__dirname, '../assets/keycloak/publicKey/public.pem'));
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, keycloak.jwt.verifyOffline(accessToken, cert)];
                    case 2:
                        verifiedToken = _a.sent();
                        return [2 /*return*/, verifiedToken.content];
                    case 3:
                        err_2 = _a.sent();
                        throw new __1.GenericValidationError({ error: new Error('Token not valid'), errorCode: 401 });
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Create the user in the database.
     * @param userData - User payload contents the user data from access token
     * @param User - Mongoose model for user
     * @returns - The saved user data
     */
    AuthMiddleware.prototype.createUser = function (userData, User) {
        return __awaiter(this, void 0, void 0, function () {
            var userId, userObj, newUser;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        userId = new mongoose_1.default.Types.ObjectId();
                        userObj = {
                            _id: userId,
                            ssoId: userData.sub,
                            firstName: userData.given_name,
                            lastName: userData.family_name,
                            email: userData.email,
                            status: "new",
                            role: "VISITOR",
                            locals: { user: { id: userId } }
                        };
                        newUser = new User(userObj);
                        return [4 /*yield*/, newUser.save()];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    ;
    /**
     * To authenticate the user by access token, and verify with our database. If the user doesn't exists, create the user and return the user details.
     * @param User - Mongoose model for user
     * @returns
     */
    AuthMiddleware.prototype.currentUser = function (User) {
        var _this = this;
        return function (req, res, next) { return __awaiter(_this, void 0, void 0, function () {
            var accessToken, token, payload, bearerToken, resource_access, client, user, _user, _userJSON, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 9, , 10]);
                        accessToken = void 0, token = void 0, payload = void 0;
                        bearerToken = req.header('Authorization');
                        // Check if it is a bearer token
                        if (bearerToken && bearerToken.startsWith('Bearer ')) {
                            accessToken = bearerToken.substring(7, bearerToken.length);
                        }
                        else {
                            accessToken = bearerToken;
                        }
                        ;
                        if (!accessToken)
                            throw new __1.GenericValidationError({ error: new Error('Access denied. No token provided.'), errorCode: 401 });
                        // Get the decoded token
                        token = this.decodeAccessToken(accessToken);
                        resource_access = token.resource_access;
                        client = token.azp;
                        if (!resource_access[client].roles.includes("NEW_USER")) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.verifyOnlineAccessToken(accessToken)];
                    case 1:
                        payload = _a.sent();
                        return [3 /*break*/, 4];
                    case 2: return [4 /*yield*/, this.verifyOfflineAccessToken(accessToken)];
                    case 3:
                        payload = _a.sent();
                        _a.label = 4;
                    case 4: return [4 /*yield*/, User.findOne({ ssoId: payload.sub })];
                    case 5:
                        user = _a.sent();
                        _user = null;
                        if (!user) return [3 /*break*/, 6];
                        _userJSON = user.toJSON();
                        res.locals.user = _userJSON;
                        return [3 /*break*/, 8];
                    case 6: return [4 /*yield*/, this.createUser(payload, User)];
                    case 7:
                        // Create user data in database
                        _user = (_a.sent());
                        if (_user)
                            res.locals.user = _user;
                        else
                            throw new __1.GenericValidationError({ error: new Error("User not created"), errorCode: 500 });
                        _a.label = 8;
                    case 8:
                        ;
                        next();
                        return [3 /*break*/, 10];
                    case 9:
                        error_1 = _a.sent();
                        return [2 /*return*/, next(error_1)];
                    case 10: return [2 /*return*/];
                }
            });
        }); };
    };
    ;
    /**
     * To authenticate the user by access token, and verify with our database. If the user doesn't exists, create the user and return the user details.
     * @param User - Mongoose model for user
     * @returns
     */
    AuthMiddleware.prototype.currentStaff = function (Staff) {
        var _this = this;
        return function (req, res, next) { return __awaiter(_this, void 0, void 0, function () {
            var accessToken, token, bearerToken, user, _userJSON, error_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 5, , 6]);
                        accessToken = void 0, token = void 0;
                        bearerToken = req.header('Authorization');
                        // Check if it is a bearer token
                        if (bearerToken && bearerToken.startsWith('Bearer ')) {
                            accessToken = bearerToken.substring(7, bearerToken.length);
                        }
                        else {
                            accessToken = bearerToken;
                        }
                        ;
                        if (!accessToken)
                            throw new __1.GenericValidationError({ error: new Error('Access denied. No token provided.'), errorCode: 401 });
                        // Get the decoded token
                        token = this.decodeAccessToken(accessToken);
                        return [4 /*yield*/, Staff.findOne({ ssoId: token.sub })];
                    case 1:
                        user = _a.sent();
                        if (!user) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.verifyOnlineAccessToken(accessToken)];
                    case 2:
                        _a.sent();
                        _userJSON = user.toJSON();
                        res.locals.user = _userJSON;
                        return [3 /*break*/, 4];
                    case 3: throw new __1.GenericValidationError({ error: new Error('Unauthorized user.'), errorCode: 401 });
                    case 4:
                        next();
                        return [3 /*break*/, 6];
                    case 5:
                        error_2 = _a.sent();
                        return [2 /*return*/, next(error_2)];
                    case 6: return [2 /*return*/];
                }
            });
        }); };
    };
    ;
    return AuthMiddleware;
}());
exports.AuthMiddleware = AuthMiddleware;
;
